diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
index c455882a6..a709f569e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
@@ -112,4 +212,668 @@ public class DensityGeneratorNether
 
         return densityMapArray;
     }
+
+    private double[] generateDensityMapFractured(Chunk chunk, int terrainHeight, int xSize, int ySize, int zSize, int x, int y, int z) {
+        double[] densityMapArray = new double[xSize * ySize * zSize];
+
+        final double mainNoiseScaleX = 80;
+        final double mainNoiseScaleY = 160;
+        final double mainNoiseScaleZ = 80;
+
+        final double scaleNoiseScaleX = 1.121;
+        final double scaleNoiseScaleZ = 1.121;
+
+        final double depthNoiseScaleX = 200;
+        final double depthNoiseScaleZ = 200;
+
+        final double depthBaseSize = 3d;
+
+        final double coordScale = 684.412D;
+        final double heightScale = 684.412D;
+
+        final double heightStretch = 12;
+
+        final double upperLimitScale = 256;
+        final double lowerLimitScale = 512;
+
+        double ravineNoiseScale = 0.03D;
+
+        double[] scaleArray = scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+
+        double[] ravineNoise = ravineNoise2.getValue(null, x, z, xSize, zSize, ravineNoiseScale, ravineNoiseScale, 3.0D, 3.0D);
+//        double[] ravineMod = ravineNoise2.getValue(null, x, z, xSize, zSize, ravineNoiseScale, ravineNoiseScale, 0.25D, 0.6D);
+
+        int mainIndex = 0;
+
+        int depthScaleIndex = 0;
+        for(int dx = 0; dx < xSize; dx++)
+        {
+            for(int dz = 0; dz < zSize; dz++)
+            {
+
+                // Calculate scale
+                double scale = (scaleArray[depthScaleIndex] + 256D) / 512D;
+                scale *= 0.5D;
+                if(scale > 1.0D)
+                {
+                    scale = 1.0D;
+                }
+
+                // Calculate depth
+                double depth = depthArray[depthScaleIndex] / 2000D;
+                if(depth < 0.0D)
+                {
+                    depth = -depth * 0.3D;
+                }
+                depth = depth * 3D - 2D;
+
+                if(depth < 0.0D)
+                {
+                    depth /= 2D;
+                    if(depth < -1D)
+                    {
+                        depth = -1D;
+                    }
+                    depth /= 1.4D;
+                    depth /= 2D;
+                    scale = 0.0D;
+                }
+                else
+                {
+                    if(depth > 1.0D)
+                    {
+                        depth = 1.0D;
+                    }
+                    depth /= 8D;
+                }
+
+                if(scale < 0.0D)
+                {
+                    scale = 0.0D;
+                }
+
+                scale += 0.5D;
+                depth = (depth * (depthBaseSize * 2)) / 16D;
+
+                double offsetY = depthBaseSize + depth * 4D;
+                depthScaleIndex++;
+
+                for(int dy = 0; dy < ySize; dy++)
+                {
+                    double density;
+                    double densityOffset = ((((double)dy - offsetY) * heightStretch) / scale);
+                    if(densityOffset < 0.0D)
+                    {
+                        densityOffset *= 4D;
+                    }
+                    double minDensity = minLimitArray[mainIndex] / upperLimitScale;
+                    double maxDensity = maxLimitArray[mainIndex] / lowerLimitScale;
+                    double mainDensity = (mainNoiseArray[mainIndex] / 10D + 1.0D) / 2D;
+
+                    // Constrain density
+                    if(mainDensity < 0.0D)
+                    {
+                        density = minDensity;
+                    }
+                    else if(mainDensity > 1.0D)
+                    {
+                        density = maxDensity;
+                    }
+                    else
+                    {
+                        density = minDensity + (maxDensity - minDensity) * mainDensity;
+                    }
+                    density -= densityOffset;
+
+                    double densityMod = (1.0f - (3F - dy)) / 3F;
+
+                    float val = (float) ravineNoise[dx * zSize + dz] * 60;
+//                    float mod = (float) ravineMod[dx * zSize + dz];
+                    if(val < 0.3){
+                        val = 0;
+                    }
+
+                    if(dy > 3) {
+                        density += (val * 6d);
+                    } else {
+                        density += (val * 4d) * (dy / (ySize / 2d)) * (dy / (ySize / 2d));
+
+                    }
+
+                    if(dy > ySize - 7)
+                    {
+                        densityMod = (float)(dy - (ySize - 7)) / 6F;
+                        density = density * (1.0D - densityMod) + 300D * densityMod;
+                    }
+
+                    densityMapArray[mainIndex] = density;
+                    mainIndex++;
+                }
+            }
+        }
+        return densityMapArray;
+    }
+
+    private double[] generateDensityMapOcean(Chunk chunk, int terrainHeight, int xSize, int ySize, int zSize, int x, int y, int z) {
+        double[] densityMapArray = new double[xSize * ySize * zSize];
+
+        final double mainNoiseScaleX = 80;
+        final double mainNoiseScaleY = 160;
+        final double mainNoiseScaleZ = 80;
+
+        final double scaleNoiseScaleX = 1.121;
+        final double scaleNoiseScaleZ = 1.121;
+
+        final double depthNoiseScaleX = 200;
+        final double depthNoiseScaleZ = 200;
+
+        final double depthBaseSize = 2.5D;
+
+        final double coordScale = 684.412D;
+        final double heightScale = 684.412D;
+
+        final double heightStretch = 12;
+
+        final double upperLimitScale = 512;
+        final double lowerLimitScale = 512;
+
+        final double noiseScale = 0.02;
+
+        double[] scaleArray = scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] islandNoiseArray = islandNoise.getValue(null, x, z, xSize, zSize, noiseScale, noiseScale, 2, 2);
+
+        int mainIndex = 0;
+
+        int depthScaleIndex = 0;
+        for(int dx = 0; dx < xSize; dx++)
+        {
+            for(int dz = 0; dz < zSize; dz++)
+            {
+                // Calculate scale
+                double scale = (scaleArray[depthScaleIndex] + 256D) / 2048D;
+                if(scale > 1.0D)
+                {
+                    scale = 1.0D;
+                }
+
+                // Calculate depth
+                double depth = depthArray[depthScaleIndex] / 2000D;
+                if(depth < 0.0D)
+                {
+                    depth = -depth * 0.3D;
+                }
+                depth = depth * 3D - 2D;
+
+                if(depth < 0.0D)
+                {
+                    depth /= 2D;
+                    if(depth < -1D)
+                    {
+                        depth = -1D;
+                    }
+                    depth /= 1.4D;
+                    depth /= 2D;
+                    scale = 0.0D;
+                }
+                else
+                {
+                    if(depth > 1.0D)
+                    {
+                        depth = 1.0D;
+                    }
+                    depth /= 8D;
+                }
+
+                if(scale < 0.0D)
+                {
+                    scale = 0.0D;
+                }
+
+                scale += 0.5D;
+                depth = (depth * (depthBaseSize * 2)) / 16D;
+
+                double offsetY = depthBaseSize + depth * 4D;
+                depthScaleIndex++;
+                for(int dy = 0; dy < ySize; dy++)
+                {
+                    double density;
+                    double densityOffset = ((((double)dy - offsetY) * heightStretch) / scale);
+                    if(densityOffset < 0.0D)
+                    {
+                        densityOffset *= 4D;
+                    }
+                    double minDensity = minLimitArray[mainIndex] / upperLimitScale;
+                    double maxDensity = maxLimitArray[mainIndex] / lowerLimitScale;
+                    double mainDensity = (mainNoiseArray[mainIndex] / 10D + 1.0D) / 2D;
+
+                    // Constrain density
+                    if(mainDensity < 0.0D)
+                    {
+                        density = minDensity;
+                    }
+                    else if(mainDensity > 1.0D)
+                    {
+                        density = maxDensity;
+                    }
+                    else
+                    {
+                        density = minDensity + (maxDensity - minDensity) * mainDensity;
+                    }
+                    density -= densityOffset;
+
+                    //Generate islands
+                    float isl = (float) islandNoiseArray[dx * zSize + dz];
+                    if(isl > 0.5) isl = isl * 100;
+                    if(isl < -0.2) isl = -isl * 100;
+
+                    if(dy > ySize - 9)
+                    {
+                        double densityMod = (float)(dy - (ySize - 10)) / 6F;
+                        density = density * (1.0D - densityMod) + 100D * densityMod;
+                    }
+
+
+                    density += isl;
+
+
+                    densityMapArray[mainIndex] = density;
+                    mainIndex++;
+                }
+            }
+        }
+        return densityMapArray;
+    }
+
+    private double[] generateDensityMapBiomeTest(Chunk chunk, int terrainHeight, int xSize, int ySize, int zSize, int x, int y, int z) {
+        double[] densityMapArray = new double[xSize * ySize * zSize];
+
+        final double mainNoiseScaleX = 80;
+        final double mainNoiseScaleY = 160;
+        final double mainNoiseScaleZ = 80;
+
+        final double scaleNoiseScaleX = 1.121;
+        final double scaleNoiseScaleZ = 1.121;
+
+        final double depthNoiseScaleX = 200;
+        final double depthNoiseScaleZ = 200;
+
+        final double depthBaseSize = 4D;
+
+        final double coordScale = 684.412D;
+        final double heightScale = 684.412D;
+
+        final double heightStretch = 12;
+
+        final double upperLimitScale = 512;
+        final double lowerLimitScale = 512;
+
+        double[] scaleArray = scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        int mainIndex = 0;
+
+        int depthScaleIndex = 0;
+        for(int dx = 0; dx < xSize; dx++)
+        {
+            for(int dz = 0; dz < zSize; dz++)
+            {
+                // Calculate scale
+                double scale = (scaleArray[depthScaleIndex] + 256D) / 2048D;
+                if(scale > 1.0D)
+                {
+                    scale = 1.0D;
+                }
+
+                // Calculate depth
+                double depth = depthArray[depthScaleIndex] / 2000D;
+                if(depth < 0.0D)
+                {
+                    depth = -depth * 0.3D;
+                }
+                depth = depth * 3D - 2D;
+
+                if(depth < 0.0D)
+                {
+                    depth /= 2D;
+                    if(depth < -1D)
+                    {
+                        depth = -1D;
+                    }
+                    depth /= 1.4D;
+                    depth /= 2D;
+                    scale = 0.0D;
+                }
+                else
+                {
+                    if(depth > 1.0D)
+                    {
+                        depth = 1.0D;
+                    }
+                    depth /= 8D;
+                }
+
+                if(scale < 0.0D)
+                {
+                    scale = 0.0D;
+                }
+
+                scale += 0.5D;
+                depth = (depth * (depthBaseSize * 2)) / 16D;
+
+                double offsetY = depthBaseSize + depth * 4D;
+                depthScaleIndex++;
+                for(int dy = 0; dy < ySize; dy++)
+                {
+                    double density;
+                    double densityOffset = ((((double)dy - offsetY) * heightStretch) / scale);
+                    if(densityOffset < 0.0D)
+                    {
+                        densityOffset *= 4D;
+                    }
+                    double minDensity = minLimitArray[mainIndex] / upperLimitScale;
+                    double maxDensity = maxLimitArray[mainIndex] / lowerLimitScale;
+                    double mainDensity = (mainNoiseArray[mainIndex] / 10D + 1.0D) / 2D;
+
+                    // Constrain density
+                    if(mainDensity < 0.0D)
+                    {
+                        density = minDensity;
+                    }
+                    else if(mainDensity > 1.0D)
+                    {
+                        density = maxDensity;
+                    }
+                    else
+                    {
+                        density = minDensity + (maxDensity - minDensity) * mainDensity;
+                    }
+                    density -= densityOffset;
+
+                    if(dy > ySize - 7)
+                    {
+                        double densityMod = (float)(dy - (ySize - 7)) / 6F;
+                        density = density * (1.0D - densityMod) + 300D * densityMod;
+                    }
+
+                    densityMapArray[mainIndex] = density;
+                    mainIndex++;
+                }
+            }
+        }
+
+        return densityMapArray;
+    }
+
+    private double[] generateDensityMapBiomeSulphurPools(Chunk chunk, int terrainHeight, int xSize, int ySize, int zSize, int x, int y, int z) {
+        double[] densityMapArray = new double[xSize * ySize * zSize];
+
+        final double mainNoiseScaleX = 8;
+        final double mainNoiseScaleY = 160;
+        final double mainNoiseScaleZ = 8;
+
+        final double scaleNoiseScaleX = 1.121 * 8192;
+        final double scaleNoiseScaleZ = 1.121 * 8192;
+
+        final double poolNoiseScale = 0.2;
+
+        final double depthNoiseScaleX = 200;
+        final double depthNoiseScaleZ = 200;
+
+        final double depthBaseSize = 3.5D;
+
+        final double coordScale = 6844.412D;
+        final double heightScale = 684.412D;
+
+        final double heightStretch = 512;
+
+        final double upperLimitScale = 512;
+        final double lowerLimitScale = 512;
+
+        double[] scaleArray = scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] poolOverArray = poolNoiseOver.getValue(null, x, z, xSize, zSize, poolNoiseScale, poolNoiseScale, 1, 0.2);
+        double[] poolUnderArray = poolNoiseUnder.getValue(null, x, z, xSize, zSize, poolNoiseScale, poolNoiseScale, 0.01, 1);
+        int mainIndex = 0;
+
+        int depthScaleIndex = 0;
+        for(int dx = 0; dx < xSize; dx++)
+        {
+            for(int dz = 0; dz < zSize; dz++)
+            {
+                // Calculate scale
+                double scale = (scaleArray[depthScaleIndex] + 256D) / 2048D;
+                if(scale > 1.0D)
+                {
+                    scale = 1.0D;
+                }
+
+                // Calculate depth
+                double depth = depthArray[depthScaleIndex] / 2000D;
+                if(depth < 0.0D)
+                {
+                    depth = -depth * 0.3D;
+                }
+                depth = depth * 3D - 2D;
+
+                if(depth < 0.0D)
+                {
+                    depth /= 2D;
+                    if(depth < -1D)
+                    {
+                        depth = -1D;
+                    }
+                    depth /= 1.4D;
+                    depth /= 2D;
+                    scale = 0.0D;
+                }
+                else
+                {
+                    if(depth > 1.0D)
+                    {
+                        depth = 1.0D;
+                    }
+                    depth /= 8D;
+                }
+
+                if(scale < 0.0D)
+                {
+                    scale = 0.0D;
+                }
+
+                scale += 0.5D;
+                depth = (depth * (depthBaseSize * 2)) / 16D;
+
+                double offsetY = depthBaseSize + depth * 4D;
+                depthScaleIndex++;
+                for(int dy = 0; dy < ySize; dy++)
+                {
+                    double density;
+                    double densityOffset = ((((double)dy - offsetY) * heightStretch) / scale);
+                    if(densityOffset < 0.0D)
+                    {
+                        densityOffset *= 4D;
+                    }
+                    double minDensity = minLimitArray[mainIndex] / upperLimitScale;
+                    double maxDensity = maxLimitArray[mainIndex] / lowerLimitScale;
+                    double mainDensity = (mainNoiseArray[mainIndex] / 10D + 1.0D) / 2D;
+
+                    // Constrain density
+                    if(mainDensity < 0.0D)
+                    {
+                        density = minDensity;
+                    }
+                    else if(mainDensity > 1.0D)
+                    {
+                        density = maxDensity;
+                    }
+                    else
+                    {
+                        density = minDensity + (maxDensity - minDensity) * mainDensity;
+                    }
+                    density -= densityOffset;
+
+                    if(dy > ySize - 12)
+                    {
+                        double densityMod = (float)(dy - (ySize - 12)) / 11F;
+                        density = density * (1.0D - densityMod) + 8000D * densityMod;
+                    }
+                    if (dy < 5) {
+                        double densityMod = (1.0f - (4 - dy)) / 4f;
+                        float val = (float) poolOverArray[dx * zSize + dz];
+                        float mod = (float) poolUnderArray[dx * zSize + dz];
+                        if (val < -20 - (20 * mod)) val = val * 80;
+                        else if (val > 20 + (20 * mod)) val = -val * 80;
+                        else val = 0;
+                        density = density * (1.0 - densityMod) + val * densityMod;
+                    }
+
+                    densityMapArray[mainIndex] = density;
+                    mainIndex++;
+                }
+            }
+        }
+
+        return densityMapArray;
+    }
+
+    private double[] generateDensityMapBiomeVolcanicIslands(Chunk chunk, int terrainHeight, int xSize, int ySize, int zSize, int x, int y, int z) {
+        double[] densityMapArray = new double[xSize * ySize * zSize];
+
+        final double mainNoiseScaleX = 80;
+        final double mainNoiseScaleY = 160;
+        final double mainNoiseScaleZ = 80;
+
+        final double scaleNoiseScaleX = 1.121 * 512;
+        final double scaleNoiseScaleZ = 1.121 * 512;
+
+        final double depthNoiseScaleX = 200;
+        final double depthNoiseScaleZ = 200;
+
+        final double depthBaseSize = 3.5D;
+
+        final double coordScale = 6844.412D;
+        final double heightScale = 684.412D;
+
+        final double heightStretch = 64;
+
+        final double upperLimitScale = 512;
+        final double lowerLimitScale = 512;
+
+        double[] scaleArray = scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        int mainIndex = 0;
+
+        int depthScaleIndex = 0;
+        for(int dx = 0; dx < xSize; dx++)
+        {
+            for(int dz = 0; dz < zSize; dz++)
+            {
+                // Calculate scale
+                double scale = (scaleArray[depthScaleIndex] + 256D) / 2048D;
+                if(scale > 1.0D)
+                {
+                    scale = 1.0D;
+                }
+
+                // Calculate depth
+                double depth = depthArray[depthScaleIndex] / 2000D;
+                if(depth < 0.0D)
+                {
+                    depth = -depth * 0.3D;
+                }
+                depth = depth * 3D - 2D;
+
+                if(depth < 0.0D)
+                {
+                    depth /= 2D;
+                    if(depth < -1D)
+                    {
+                        depth = -1D;
+                    }
+                    depth /= 1.4D;
+                    depth /= 2D;
+                    scale = 0.0D;
+                }
+                else
+                {
+                    if(depth > 1.0D)
+                    {
+                        depth = 1.0D;
+                    }
+                    depth /= 8D;
+                }
+
+                if(scale < 0.0D)
+                {
+                    scale = 0.0D;
+                }
+
+                scale += 0.5D;
+                depth = (depth * (depthBaseSize * 2)) / 16D;
+
+                double offsetY = depthBaseSize + depth * 4D;
+                depthScaleIndex++;
+                for(int dy = 0; dy < ySize; dy++)
+                {
+                    double density;
+                    double densityOffset = ((((double)dy - offsetY) * heightStretch) / scale);
+                    if(densityOffset < 0.0D)
+                    {
+                        densityOffset *= 4D;
+                    }
+                    double minDensity = minLimitArray[mainIndex] / upperLimitScale;
+                    double maxDensity = maxLimitArray[mainIndex] / lowerLimitScale;
+                    double mainDensity = (mainNoiseArray[mainIndex] / 10D + 1.0D) / 2D;
+
+                    // Constrain density
+                    if(mainDensity < 0.0D)
+                    {
+                        density = minDensity;
+                    }
+                    else if(mainDensity > 1.0D)
+                    {
+                        density = maxDensity;
+                    }
+                    else
+                    {
+                        density = minDensity + (maxDensity - minDensity) * mainDensity;
+                    }
+                    density -= densityOffset;
+
+                    if (dy < 4) {
+                        double densityMod = (1.0f - (3 - dy)) / 3f;
+                        density = density * (1.0 - densityMod) + scaleArray[dx * zSize + dz] * densityMod;
+                    }
+                    if(dy > ySize - 8)
+                    {
+                        double densityMod = (float)(dy - (ySize - 8)) / 7F;
+                        density = density * (1.0D - densityMod) + 8000D * densityMod;
+                    }
+
+                    densityMapArray[mainIndex] = density;
+                    mainIndex++;
+                }
+            }
+        }
+
+        return densityMapArray;
+    }
+
+
 }
